=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# install all files into temporary destdir
DESTDIR=$(CURDIR)/debian/tmp

%:
	dh $@ 

override_dh_auto_clean:
	rm -rf build-*
	rm -rf .waf*
	rm -rf .lock*

override_dh_auto_configure:
	./waf configure \
		--prefix=/usr \
		--libdir=/usr/lib/$(DEB_BUILD_MULTIARCH)

override_dh_auto_install:
	./waf install \
		--destdir=$(DESTDIR)
